# 树莓派如何使用感为灰度传感器

注意: 树莓派官方未表明支持5V输入,所以不能插传感器的SDA/SCL 5V跳线帽,需要使用内置或外置3.3V上拉

此例程由群友热心提供,因此 此例程无任何售后保证,仅供参考

### 简单用命令行测试
需要安装`i2c-tools`, 安装命令:

`sudo apt-get install -y i2c-tools`

##### 查看是否树莓派启用I2C

```bash
raspberrypi@rasberrypi:~ $ i2cdetect -l
i2c-1	i2c       	bcm2835 (i2c@7e804000)          	I2C adapter
```

返回不应该为空,如果为空自行搜索如何启用I2C

##### 查看设备是否连接

```bash
rasberrypi@rasberrypi:~ $ i2cdetect -y -r 1
     0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
00:                         -- -- -- -- -- -- -- -- 
10: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
20: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
30: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
40: -- -- -- -- -- -- -- -- -- -- -- -- 4c -- -- -- 
50: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
60: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
70: -- -- -- -- -- -- -- --   
```

上面`0x4C`是感为灰度默认地址,使用手册中的ping试试
```bash
rasberrypi@rasberrypi:~ $ i2cget -f -y 1 0x4c 0xAA
0x66
```

设备返回`0x66`代表通讯成功

##### 读取数字量数据:
`i2cget -y 1 0x4c 0xdd`
返回一个单字节,这个字节的每一个探头都是一路的开关量
